org.apache.bcel.classfile

## Class LineNumberTable

- java.lang.Object
- - org.apache.bcel.classfile.Attribute
  - - org.apache.bcel.classfile.LineNumberTable

- All Implemented Interfaces:
    Cloneable, Node

      public final class LineNumberTable
      extends Attribute

  This class represents a table of line numbers for debugging purposes. This attribute is used by the Code attribute. It contains pairs of PCs and line numbers.
  Version:
    $Id: LineNumberTable.java 1806200 2017-08-25 16:33:06Z ggregory $
  See Also:
    `Code`, `LineNumber`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.classfile.Attribute

      `constant_pool, length, name_index, tag`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LineNumberTable(int name_index, int length, LineNumber[] line_number_table, ConstantPool constant_pool)`
    `LineNumberTable(LineNumberTable c)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class.
    `Attribute` | `copy(ConstantPool _constant_pool)`
    `void` | `dump(DataOutputStream file)` Dump line number table attribute to file stream in binary format.
    `LineNumber[]` | `getLineNumberTable()`
    `int` | `getSourceLine(int pos)` Map byte code positions to source code lines.
    `int` | `getTableLength()`
    `void` | `setLineNumberTable(LineNumber[] line_number_table)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.bcel.classfile.Attribute

      `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### LineNumberTable

          public LineNumberTable(LineNumberTable c)

    - #### LineNumberTable

          public LineNumberTable(int name_index,
                                 int length,
                                 LineNumber[] line_number_table,
                                 ConstantPool constant_pool)

  - ### Method Detail

    - #### accept

          public void accept(Visitor v)

      Called by objects that are traversing the nodes of the tree implicitely defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
      Specified by:
        `accept` in interface `Node`
      Specified by:
        `accept` in class `Attribute`
      Parameters:
        `v` - Visitor object

    - #### dump

          public final void dump(DataOutputStream file)
                          throws IOException

      Dump line number table attribute to file stream in binary format.
      Overrides:
        `dump` in class `Attribute`
      Parameters:
        `file` - Output file stream
      Throws:
        `IOEXception` - if an I/O Exception occurs in writeShort
        `IOException`

    - #### getLineNumberTable

          public final LineNumber[] getLineNumberTable()

      Returns:
        Array of (pc offset, line number) pairs.

    - #### setLineNumberTable

          public final void setLineNumberTable(LineNumber[] line_number_table)

      Parameters:
        `line_number_table` - the line number entries for this table

    - #### toString

          public final String toString()

      Overrides:
        `toString` in class `Attribute`
      Returns:
        String representation.

    - #### getSourceLine

          public int getSourceLine(int pos)

      Map byte code positions to source code lines.
      Parameters:
        `pos` - byte code offset
      Returns:
        corresponding line in source code

    - #### copy

          public Attribute copy(ConstantPool _constant_pool)

      Specified by:
        `copy` in class `Attribute`
      Returns:
        deep copy of this attribute

    - #### getTableLength

          public final int getTableLength()

Copyright © 2004–2017 The Apache Software Foundation. All rights reserved.